SVC Struct Reference
Encoder Algorithm » Scalable Video Coding

The stucture of SVC. More...

`#include <svc_layercontext.h>`

## Data Fields

LAYER_CONTEXT * | layer_context
int | num_allocated_layers
InterpFilter | downsample_filter_type [4]
int | downsample_filter_phase [4]
int | force_zero_mode_spatial_ref
int | has_lower_quality_layer
AOM_SVC_FRAME_DROP_MODE | framedrop_mode
bool | last_layer_dropped [4]
bool | drop_spatial_layer [4]

## Detailed Description

The stucture of SVC.

## Field Documentation

## layer_context

LAYER_CONTEXT* SVC::layer_context

Layer context used for rate control in CBR mode. An array. The index for spatial layer sl and temporal layer tl is sl * number_temporal_layers + tl.

Referenced by av1_alloc_layer_context(), av1_encodedframe_overshoot_cbr(), av1_free_svc_cyclic_refresh(), av1_init_layer_context(), av1_one_pass_cbr_svc_start_layer(), av1_postencode_drop_cbr(), av1_svc_reset_temporal_layers(), av1_update_layer_context_change_config(), av1_update_temporal_layer_framerate(), encode_nonrd_sb(), get_layer_context(), and grade_source_content_sb().

## num_allocated_layers

int SVC::num_allocated_layers

Number of layers allocated for layer_context. If nonzero, must be greater than or equal to number_spatial_layers * number_temporal_layers.

Referenced by av1_alloc_layer_context(), and av1_free_svc_cyclic_refresh().

## downsample_filter_type

InterpFilter SVC::downsample_filter_type[4]

EIGHTTAP_SMOOTH or BILINEAR

Referenced by av1_init_layer_context(), av1_one_pass_cbr_svc_start_layer(), and encode_without_recode().

## downsample_filter_phase

int SVC::downsample_filter_phase[4]

Downsample_filter_phase: = 0 will do sub-sampling (no weighted average), = 8 will center the target pixel and get a symmetric averaging filter.

Referenced by av1_init_layer_context(), av1_nonrd_pick_inter_mode_sb(), and encode_without_recode().

## force_zero_mode_spatial_ref

int SVC::force_zero_mode_spatial_ref

Force zero-mv in mode search for the spatial/inter-layer reference.

Referenced by av1_init_layer_context(), and av1_restore_layer_context().

## has_lower_quality_layer

int SVC::has_lower_quality_layer

Flag to indicate that current spatial layer has a lower quality layer (at the same timestamp) that can be used as a reference. Lower quality layer refers to the same resolution but encoded at different/lower bitrate.

Referenced by av1_init_layer_context(), av1_nonrd_pick_inter_mode_sb(), and av1_one_pass_cbr_svc_start_layer().

## framedrop_mode

AOM_SVC_FRAME_DROP_MODE SVC::framedrop_mode

Flag to indicate the frame drop mode for SVC: one of the two settings: AOM_LAYER_DROP (default) or AOM_FULL_SUPERFRAME_DROP.

## last_layer_dropped

bool SVC::last_layer_dropped[4]

Flag to indicate if frame was dropped for a given spatial_layer_id on previous superframe.

Referenced by av1_init_layer_context().

## drop_spatial_layer

bool SVC::drop_spatial_layer[4]

Flag to indicate if a previous spatial was dropped for the same superframe.

Referenced by av1_init_layer_context(), and av1_save_layer_context().

The documentation for this struct was generated from the following file:

- av1/encoder/svc_layercontext.h